<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin'))
{
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentPaybylink extends vmPSPlugin 
{

    public static $_this = false;

    function __construct(& $subject, $config) 
	{
		parent::__construct($subject, $config);
		
		$this->_loggable = true;
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$this->tableFields = array_keys($this->getTableSQLFields());
		$varsToPush = array(
			'pbl_shopid' => array('', 'string'),
			'pbl_hash' => array('', 'string'),
			'auto_redirect' => array(1, 'int'),
			'powiadomienia' => array(1, 'int'),
			'tax_id' => array(0, 'int'),
			'url_pozytywny' => array('', 'string'),
			'url_online' => array('', 'string'),
			'status_pending' => array('', 'string'),
			'status_success' => array('', 'string'),
			'status_canceled' => array('', 'string'),
			'auto_potwierdz' => array(1, 'int'),
	    );
		
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
		
	}
	
	
	
	function getTableSQLFields()
	{
	    $SQLfields = array
	    (
	        'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(11) UNSIGNED',
            'order_number' => 'varchar(32)',
            'virtuemart_paymentmethod_id' => 'mediumint(1)',
	        'payment_name' => 'varchar(255)',
	        'tax_id' => 'int(11)',
	        'status'=>'varchar(255)'
	    );
	    return $SQLfields;
	}
	
	protected function getVmPluginCreateTableSQL()
	{
	    return $this->createTableSQL('Platnosci Paybylink');
	}
	
	
	function plgVmPotwierdzeniePaybylink($cart, $order, $auto_redirect = false, $form_method = "POST")
	{
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Inna metoda została wybrana, nie rób nic.
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}

		if (!class_exists('VirtueMartModelOrders')){
			require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		
		$this->getPaymentCurrency($method);
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		
		$amount = round($paymentCurrency->convertCurrencyTo(114, $order['details']['BT']->order_total, false), 2);
		
		$orderDetails = $order['details']['BT'];
		
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['order_number'] = $orderDetails->order_number;
		$dbValues['tax_id'] = $method->tax_id;
		$dbValues['status'] = 'Rozpoczete';
		$dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
		$this->storePSPluginInternalData($dbValues);
		
		$shopId             = intval($method->pbl_shopid);
		$description        = strval('Zamówienie ' . $orderDetails->order_number);
		$control            = strval($orderDetails->order_number);
		$email              = strval($orderDetails->email);
		$price              = floatval($amount);
		$notifyURL          = strval(JUri::base() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm='. $orderDetails->virtuemart_paymentmethod_id . '&status=confirm');
		$returnUrlSuccess   = strval(JUri::base() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm='. $orderDetails->virtuemart_paymentmethod_id . '&status=ok');
		$hash               = $method->pbl_hash;
	
		$data   = $hash . "|" . $shopId . "|" . sprintf("%.2f", $price);
	
		if ($control != null && $control != "") {
			$data .= "|" . $control;
		}
	
		if ($description != null && $description != "") {
			$data .= "|" . $description;
		}
		
		if ($email != null && $email != "") {
			$data .= "|" . $email;
		}
	
		if ($notifyURL != null && $notifyURL != "") {
			$data .= "|" . $notifyURL;
		}
	
		if ($returnUrlSuccess != null && $returnUrlSuccess != "") {
			$data .= "|" . $returnUrlSuccess;
		}
	
		$signature = hash('sha256', $data);
	
		$paybylinkData  = [
			'shopId'            => $shopId,
			'price'             => $price,
			'control'           => $control,
			'description'       => $description,
			'email'             => $email,
			'notifyURL'         => $notifyURL,
			'returnUrlSuccess'  => $returnUrlSuccess,
			'signature'         => $signature
		];
	
		$data_string = json_encode($paybylinkData);
	
		$ch = curl_init('https://secure.pbl.pl/api/v1/transfer/generate');                                                                      
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');                                                                    
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
		curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
			'Content-Type: application/json',                                                                                
			'Content-Length: ' . strlen($data_string))                                                                      
		);
	
		$result = curl_exec($ch);
		$result = json_decode($result);
	
		if(isset($result->transactionId) AND !empty($result->transactionId)) {
			$payURL = 'https://secure.pbl.pl/transfer/' . $result->transactionId;
		}
	
		header('Location: ' . $payURL);
		exit('<a href="' . $payURL . '">Kliknij tutaj jeśli nie zostaniesz przekierowany do płatności</a>');
	}
	
	function plgVmConfirmedOrder($cart, $order)
	{

		if (!($html = $this->plgVmPotwierdzeniePaybylink($cart, $order, true))) {
			return false; 
		}
		
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) 
		{
			return null;
		}
		$nazwa_platnosci = $this->renderPluginName($method);
		
		return $this->processConfirmedOrderPaymentResponse(1, $cart, $order, $html, $nazwa_platnosci, $method->status_pending);
	}

	public function checkSignature($secret, $data){
		$sign = sprintf("%s|%s|%s|%s|%.2f|%d|%s|%d", $secret, $data['transactionId'], $data['control'], $data['email'], $data['amountPaid'], $data['notificationAttempt'], $data['paymentType'], $data['apiVersion']);
		$hash = hash('sha256', $sign);
		return $hash == $data['signature'];
	}
	
	function plgVmOnPaymentResponseReceived(&$html) 
	{
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; 
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}

		if(isset($_GET['status'])) {
			if($_GET['status'] == 'confirm') {
				$_POST = json_decode(file_get_contents('php://input'), true);
				if($this->checkSignature($method->pbl_hash, $_POST))
				{
					if(!class_exists('VirtueMartModelOrders'))
						require (JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
						
					$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($_POST['control']);
		
					$message = 'Wpłata w kwocie '.$_POST['amountPaid'].' PLN została zaksięgowana dla zamówienia o ID : '.$_POST['control'];
					$this->paymentNewStatus($virtuemart_order_id,$method->status_success,$message,$method->powiadomienia);
		
					echo 'OK';    
					exit();    
				}
					
				echo 'BLAD SYGNATURY';
				exit();
			} else {
				JFactory::getApplication()->enqueueMessage('Dziękujemy za dokonanie transakcji za pośrednictwem paybylink.pl.');

                return true;
			}
		}
	}

	public function paymentNewStatus($virtuemart_order_id, $status, $comment, $notification )
	{

	    if(!class_exists('VirtueMartModelOrders'))
	        require (JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
	    $modelOrder = new VirtueMartModelOrders();
	    $order['order_status'] = $status;
	    $order['virtuemart_order_id'] = $virtuemart_order_id;
	    $order['customer_notified'] = $notification;
	    $order['comments'] = $comment;
	    $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
	    return true;
	
	}

    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) 
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
			return null;
		}

		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			vmWarn(500, $q . " " . $db->getErrorMsg());
			return '';
		}
		
		$this->getPaymentCurrency($paymentTable);

		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('Payment', $paymentTable->payment_name);	
		$html .= $this->getHtmlRowBE('Order Number', $paymentTable->order_number);
		$html .= $this->getHtmlRowBE('Order ID', $paymentTable->virtuemart_order_id);
		$html .= '</table>' . "\n";
		return $html;
    }
	

	
     function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		return 0;
    }


    protected function checkConditions($cart, $method, $cart_prices) {
		return true;
    }

    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

	return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	return $this->OnSelectCheck($cart);
    }


    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
	return $this->displayListFE($cart, $selected, $htmlIn);
    }


    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
	return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
	return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    protected function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	  $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }
    public function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        // nadpisujemy parametr , aby edycja nic mu nie robiła!
        $virtuemart_paymentmethod_id = $_GET['cid'][0];
        $url_pozytywny = 'url_pozytywny="' . JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $virtuemart_paymentmethod_id . '"|';
        $url_online = 'url_online="' . JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $virtuemart_paymentmethod_id . '"|';
        $data->payment_params .= $url_pozytywny;
        $data->payment_params .= $url_online;

        return $this->declarePluginParams('payment', $data);
    }

    public function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }
}